<template>
  <div class="repository-files">
    <div class="breadcrumbs">
      <span> /{{ path.join(" / ") }} </span>
    </div>
    <div class="file-list">
      <div class="item" @click="back()" v-if="path.length > 0">
        ..
      </div>

      <div v-if="files.length > 0 && !file">
        <File
          v-for="(file, index) in files"
          :file="file"
          :name="file.name"
          :key="index"
          :is-folder="file.isTree"
          @open="open(file)"
        ></File>
      </div>
      <div v-else-if="file" class="file">
        <AceEditor
          :fontSize="14"
          :showPrintMargin="true"
          :showGutter="true"
          :highlightActiveLine="true"
          mode="javascript"
          :theme="this.darkMode ? 'cobalt' : 'eclipse'"
          :onChange="onChange"
          name="editor"
          :editorProps="{ $blockScrolling: true }"
          :defaultValue="file.file"
          :class="'editor'"
          :readOnly="true"
          :width="'100%'"
        />
      </div>
      <div class="nofiles" v-else>
        <img src="../../../assets/empty.svg" alt="" />
        No files found, commit something first!
      </div>
    </div>
  </div>
</template>

<script>
import File from "./File";
import { mapState } from "vuex";

export default {
  components: {
    File
  },
  data() {
    return {
      files: [],
      file: null,
      path: []
    };
  },
  methods: {
    open(file) {
      this.path.push(file.name);
    },
    back() {
      this.path.pop();
      this.$router.push({
        name: "Project",
        query: { repository: this.repository.id, path: this.path.join("/") }
      });
    },
    getFiles() {
      this.$apiService
        .getFiles(this.project, this.repository.name, this.branch, this.path)
        .then(({ data }) => {
          if (data.type === "tree") {
            this.files = data.files;
            this.file = null;
          } else if (data.type === "file") {
            this.file = data;
          }
        });
    }
  },
  props: {
    repository: {
      required: true,
      type: Object
    },
    branch: {
      required: true,
      type: String
    },
    project: {
      required: true,
      type: String
    }
  },
  watch: {
    branch: function() {
      this.path = [];
      this.$router.push({
        name: "Repositories",
        query: { repository: this.repository.id, path: this.path.join("/") }
      });
      this.file = null;
      this.getFiles();
    },
    path: function() {
      this.getFiles();
      this.$router.push({
        name: "Repositories",
        query: { repository: this.repository.id, path: this.path.join("/") }
      });
    }
  },
  mounted() {
    if (this.branch) {
      if (this.$route.query.path) {
        this.path = this.$route.query.path.split("/");
      }
      this.getFiles();
    }
  },
  computed: mapState(["darkMode"])
};
</script>

<style lang="scss" scoped>
.repository-files {
  margin-bottom: 40px;
  &.hidden {
    display: none;
  }
  .breadcrumbs {
    margin-bottom: 1px;
    span {
      padding-left: 10px;
      padding-right: 10px;
      padding-top: 2px;
      padding-bottom: 2px;
      color: #2c2c2c;
      background-color: #f6f6f6;
      border-top: 1px solid #e5e5e5;
      border-left: 1px solid #e5e5e5;
      border-right: 1px solid #e5e5e5;
      border-top-left-radius: 8px;
      border-top-right-radius: 8px;
      transition: background-color 0.1s ease-out, border-color 0.1s ease-out;
      & > i {
        margin-right: 10px;
      }
    }

    text-align: right;
  }

  .file-list {
    border: 1px solid #e5e5e5;
    border-radius: 8px;
    overflow: hidden;
    border-top-right-radius: 0;
    transition: background-color 0.1s ease-out, border-color 0.1s ease-out;
    .nofiles {
      padding: 20px;
      display: flex;
      justify-content: center;
      align-items: center;
      font-weight: 600;
      img {
        max-width: 200px;
        max-height: 200px;
      }
    }
  }

  margin-top: 20px;
  width: 100%;

  .item {
    border-top: 1px solid #e5e5e5;
    padding: 10px;
    padding-left: 15px;
    transition: background-color 0.1s ease-out, border-color 0.1s ease-out,
      color 0.1s ease-out;
    i {
      margin-right: 10px;
    }

    &:first-child {
      border-top: none;
    }

    &:hover {
      cursor: pointer;
    }

    user-select: none;
  }
}
#app {
  &.darkMode {
    .repository-files {
      .file-list {
        background-color: #293039;
        border-color: #25282e;
        .item {
          border-color: #25282e;
          color: #6d7c87;
          &:hover {
            color: #94a3af;
          }
          .editor {
            width: 100%;
          }
        }
        .nofiles {
          color: #5c6d76;
        }
      }
      .breadcrumbs {
        span {
          background-color: #293039;
          border-color: #25282e;
          color: #6d7c87;
          font-weight: 600;
        }
      }
    }
  }
}
</style>
